-----------------------------
--slot_counter.vhd
-----------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity slot_counter is
    generic (
        C_CNT_WIDTH : integer := 4
    );
    
    Port ( 
        SYS_CLK : in STD_LOGIC;
        SYS_RST : in STD_LOGIC;
        count : out STD_LOGIC_VECTOR(0 to C_CNT_WIDTH-1)
    );
end slot_counter;

architecture IMP of slot_counter is
    signal count_w : STD_LOGIC_VECTOR(0 to C_CNT_WIDTH-1); 
begin

    process(SYS_CLK)
    begin
        if SYS_CLK'event and SYS_CLK = '1' then 
            if SYS_RST = '1' then
                count_w <= (others => '0');
            else
                count_w <= count_w + 1;
            end if;
        end if;
    end process;

    count <= count_w;

end IMP;

